#last edited dec1115
#Brian Campbell-Deem cmpblld2
#MATH198
#Physible pt. 1

from visual import *
from visual.graph import *
import time
import numpy.random as rand

g=9.8
scene.visible=True
scene.title = "Kinematics"
scene.autoscale=False

def get_right_value(num):
	while(1):
		try:
			value = float(raw_input(num))
		except ValueError:
			continue

		if(value>50 or value<4.9):
			continue
		else:
			break
	return value

while(1):
	v_x = rand.random_integers(-40,40)
	v_y = get_right_value("Please enter y velocity (4.9 to 50 m/s): ")
	v_z = rand.random_integers(-40,40)

	if(v_y<10):
		radius=1
	elif(v_y<25):
		radius=3
	else:
		radius=5
	ball = sphere(pos=(0,0,0), radius=radius, color=color.red, velocity=vector(v_x, v_y, v_z), make_trail=true, material=materials.emissive)


	speed = math.sqrt(math.pow(v_x, 2) + math.pow(v_y, 2) + math.pow(v_z, 2))
	air_time = v_y*2/g
	acceleration = vector(0,-1*g,0)
	ground = box(pos=(0, 0 - ball.radius, 0), length=3*speed*air_time + ball.radius*10, width=3*speed*air_time + ball.radius*10, height=0.1, material=materials.rough, color=color.green)

	#varr=arrow(pos=ball.pos + (0, ball.velocity.magnitude, 0), axis = ball.velocity, color = color.blue)

	sky = box(pos=(0,ground.length/2 + ground.y, 0), length=ground.length, width=ground.length, height=ground.length, color=color.cyan, material=materials.emissive)
	sun = local_light(pos=(0,0, sky.width), color=color.white)

	scene.range= sqrt(v_x**2 + v_z**2) * air_time
	scene.forward=(v_z, 0, -1*v_x) #makes camera look perpendicular to the path of motion.
	scene.forward=scene.forward.rotate(angle=-0.15, axis=(v_x, 0, v_z))
	scene.center=(v_x*air_time/2, 0, v_z*air_time/2)

	tcount=0


	dt=0.001

	max_y=max(v_y*air_time/4, v_y)
	min_y=min(-1*g -1, -1*v_y)
	g1 = gdisplay(x=scene.width, y=0, title="y attributes", xtitle='Time', ytitle='Magnitude', xmin=-air_time/9.8, xmax=air_time, ymin=min_y, ymax=max_y)
	yposg = gcurve(color=ball.color)
	yvelg = gcurve(color=color.blue)
	yaccelg = gcurve(color=color.cyan)

	label(display=g1.display, pos=(-air_time/10.0, v_y), text="v_y", color=color.blue)
	label(display=g1.display, pos=(-air_time/10.0, v_y/10.0), text="y", color=color.red)
	label(display=g1.display, pos=(-air_time/10.0, -g), text="a_y", color=color.cyan)

	while(1):
		rate(1.0/dt)

		yposg.plot(pos=(tcount,ball.pos.y))
		yvelg.plot(pos=(tcount,ball.velocity.y))
		yaccelg.plot(pos=(tcount,-1*g))
		tcount+=dt
		
		#varr.axis = ball.velocity
		ball.pos += ball.velocity*dt
		ball.velocity += acceleration*dt

		if(ball.pos.y<=0):
			#t=time.clock() - t
			break

	flag = "init"
	while( (flag!="y") and (flag!="n") and (flag!="yes") and (flag!="no") ):	
		flag = raw_input("Would you like to run the program again? (y/n): ")

	if( (flag=="y") or (flag=="yes") ):
		window.delete_all()
		scene = display()
		scene.select()
		continue
	else:
		exit()

#print v_y
#print t
#print air_time

#print (abs(t-air_time)/air_time)*100

#prog="foo"
#while(prog != "bs"):
#	prog = raw_input("Please enter program: ")

#ball.visible=0
#ball.trail_object.visible=0
#ground.visible=0
#import bs.py
#scene.visible=0
